Codeforces 567C:Geometric Progression(DP)

time limit per test : 1 secondios

memory limit per test : 256 megabytesc++

input : standard inputthis

output : standard outputspa

Problem Description

 Polycarp loves geometric progressions very much. Since he was only three years old, he loves only the progressions of length three. He also has a favorite integer \(k\) and a sequence \(a\), consisting of \(n\) integers.code

He wants to know how many subsequences of length three can be selected from \(a\), so that they form a geometric progression with common ratio \(k\).orm

A subsequence of length three is a combination of three such indexes \(i_1, i_2, i_3\), that \(1 ≤ i_1 < i_2 < i_3 ≤ n\). That is, a subsequence of length three are such groups of three elements that are not necessarily consecutive in the sequence, but their indexes are strictly increasing.three

A geometric progression with common ratio \(k\) is a sequence of numbers of the form \(b·k^0, b·k^1, ..., b·k^{r - 1}\).Polycarp is only three years old, so he can not calculate this number himself. Help him to do it.ip

Input

The first line of the input contains two integers, \(n\) and \(k (1 ≤ n, k ≤ 2·10^5)\), showing how many numbers Polycarp's sequence has and his favorite number.ci

The second line contains \(n\) integers \(a_1, a_2, ..., a_n ( - 10^9 ≤ a_i ≤ 10^9)\) — elements of the sequence.element

Output

Output a single number — the number of ways to choose a subsequence of length three, such that it forms a geometric progression with a common ratio \(k\).

Examples

input

5 2
1 1 2 2 4

output

4

input

3 1
1 1 1

output

1

input

10 3
1 2 6 2 3 6 9 18 3 9

output

6

Note

In the first sample test the answer is four, as any of the two 1s can be chosen as the first element, the second element can be any of the 2s, and the third element of the subsequence must be equal to 4.

題意

\(n\)個數中選出三個數,要求組成的序列公比爲\(k\),而且不改變這三個數的先後關係,問有多少種選擇方案

思路

\(DP\),由於\(- 10^9 ≤ a_i ≤ 10^9\) ,因此還須要用到\(map\)

定義\(dp[i][j]\)表示把數字\(j\)放在等比數列第\(i\)個位置的方案數

\(dp[i][j]+=dp[i-1][j/k]\)

將全部長度爲\(3\)的方案數加起來便可

代碼

#include <bits/stdc++.h>
#define ll long long
#define ull unsigned long long
#define ms(a,b) memset(a,b,sizeof(a))
const int inf=0x3f3f3f3f;
const ll INF=0x3f3f3f3f3f3f3f3f;
const int maxn=1e6+10;
const int mod=1e9+7;
const int maxm=1e3+10;
using namespace std;
ll a[maxn];
int main(int argc, char const *argv[])
{
    #ifndef ONLINE_JUDGE
        freopen("/home/wzy/in", "r", stdin);
        freopen("/home/wzy/out", "w", stdout);
        srand((unsigned int)time(NULL));
    #endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n,k;
    cin>>n>>k;
    map<int,ll>dp[4];
    ll ans=0;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
        if(a[i]%k==0)
        {
            ans+=dp[2][a[i]/k];
            dp[2][a[i]]+=dp[1][a[i]/k];
        }
        dp[1][a[i]]++;
    }
    cout<<ans<<endl;
    #ifndef ONLINE_JUDGE
        cerr<<"Time elapsed: "<<1.0*clock()/CLOCKS_PER_SEC<<" s."<<endl;
    #endif
    return 0;
}
相關文章
相關標籤/搜索